package com.hfkj.dao;

import com.hfkj.entity.BsTradeTakeConfig;
import com.hfkj.entity.BsTradeTakeConfigExample.Criteria;
import com.hfkj.entity.BsTradeTakeConfigExample.Criterion;
import com.hfkj.entity.BsTradeTakeConfigExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsTradeTakeConfigSqlProvider {

    public String countByExample(BsTradeTakeConfigExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_trade_take_config");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsTradeTakeConfigExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_trade_take_config");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsTradeTakeConfig record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_trade_take_config");
        
        if (record.getCompanyId() != null) {
            sql.VALUES("company_id", "#{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.VALUES("company_name", "#{companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.VALUES("platform_type", "#{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformTypeName() != null) {
            sql.VALUES("platform_type_name", "#{platformTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverRole() != null) {
            sql.VALUES("receiver_role", "#{receiverRole,jdbcType=INTEGER}");
        }
        
        if (record.getReceiverRoleName() != null) {
            sql.VALUES("receiver_role_name", "#{receiverRoleName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverAccount() != null) {
            sql.VALUES("receiver_account", "#{receiverAccount,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverName() != null) {
            sql.VALUES("receiver_name", "#{receiverName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverRatio() != null) {
            sql.VALUES("receiver_ratio", "#{receiverRatio,jdbcType=DECIMAL}");
        }
        
        if (record.getReceiverObjectId() != null) {
            sql.VALUES("receiver_object_id", "#{receiverObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getReceiverObjectName() != null) {
            sql.VALUES("receiver_object_name", "#{receiverObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverRole() != null) {
            sql.VALUES("sub_receiver_role", "#{subReceiverRole,jdbcType=INTEGER}");
        }
        
        if (record.getSubReceiverRoleName() != null) {
            sql.VALUES("sub_receiver_role_name", "#{subReceiverRoleName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverAccount() != null) {
            sql.VALUES("sub_receiver_account", "#{subReceiverAccount,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverName() != null) {
            sql.VALUES("sub_receiver_name", "#{subReceiverName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverRatio() != null) {
            sql.VALUES("sub_receiver_ratio", "#{subReceiverRatio,jdbcType=DECIMAL}");
        }
        
        if (record.getSubReceiverObjectId() != null) {
            sql.VALUES("sub_receiver_object_id", "#{subReceiverObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getSubReceiverObjectName() != null) {
            sql.VALUES("sub_receiver_object_name", "#{subReceiverObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.VALUES("op_user_id", "#{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.VALUES("op_user_name", "#{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsTradeTakeConfigExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("company_id");
        sql.SELECT("company_name");
        sql.SELECT("platform_type");
        sql.SELECT("platform_type_name");
        sql.SELECT("receiver_role");
        sql.SELECT("receiver_role_name");
        sql.SELECT("receiver_account");
        sql.SELECT("receiver_name");
        sql.SELECT("receiver_ratio");
        sql.SELECT("receiver_object_id");
        sql.SELECT("receiver_object_name");
        sql.SELECT("sub_receiver_role");
        sql.SELECT("sub_receiver_role_name");
        sql.SELECT("sub_receiver_account");
        sql.SELECT("sub_receiver_name");
        sql.SELECT("sub_receiver_ratio");
        sql.SELECT("sub_receiver_object_id");
        sql.SELECT("sub_receiver_object_name");
        sql.SELECT("`status`");
        sql.SELECT("op_user_id");
        sql.SELECT("op_user_name");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_trade_take_config");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsTradeTakeConfig record = (BsTradeTakeConfig) parameter.get("record");
        BsTradeTakeConfigExample example = (BsTradeTakeConfigExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_trade_take_config");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.SET("company_name = #{record.companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformTypeName() != null) {
            sql.SET("platform_type_name = #{record.platformTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverRole() != null) {
            sql.SET("receiver_role = #{record.receiverRole,jdbcType=INTEGER}");
        }
        
        if (record.getReceiverRoleName() != null) {
            sql.SET("receiver_role_name = #{record.receiverRoleName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverAccount() != null) {
            sql.SET("receiver_account = #{record.receiverAccount,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverName() != null) {
            sql.SET("receiver_name = #{record.receiverName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverRatio() != null) {
            sql.SET("receiver_ratio = #{record.receiverRatio,jdbcType=DECIMAL}");
        }
        
        if (record.getReceiverObjectId() != null) {
            sql.SET("receiver_object_id = #{record.receiverObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getReceiverObjectName() != null) {
            sql.SET("receiver_object_name = #{record.receiverObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverRole() != null) {
            sql.SET("sub_receiver_role = #{record.subReceiverRole,jdbcType=INTEGER}");
        }
        
        if (record.getSubReceiverRoleName() != null) {
            sql.SET("sub_receiver_role_name = #{record.subReceiverRoleName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverAccount() != null) {
            sql.SET("sub_receiver_account = #{record.subReceiverAccount,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverName() != null) {
            sql.SET("sub_receiver_name = #{record.subReceiverName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverRatio() != null) {
            sql.SET("sub_receiver_ratio = #{record.subReceiverRatio,jdbcType=DECIMAL}");
        }
        
        if (record.getSubReceiverObjectId() != null) {
            sql.SET("sub_receiver_object_id = #{record.subReceiverObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getSubReceiverObjectName() != null) {
            sql.SET("sub_receiver_object_name = #{record.subReceiverObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_trade_take_config");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("company_id = #{record.companyId,jdbcType=BIGINT}");
        sql.SET("company_name = #{record.companyName,jdbcType=VARCHAR}");
        sql.SET("platform_type = #{record.platformType,jdbcType=INTEGER}");
        sql.SET("platform_type_name = #{record.platformTypeName,jdbcType=VARCHAR}");
        sql.SET("receiver_role = #{record.receiverRole,jdbcType=INTEGER}");
        sql.SET("receiver_role_name = #{record.receiverRoleName,jdbcType=VARCHAR}");
        sql.SET("receiver_account = #{record.receiverAccount,jdbcType=VARCHAR}");
        sql.SET("receiver_name = #{record.receiverName,jdbcType=VARCHAR}");
        sql.SET("receiver_ratio = #{record.receiverRatio,jdbcType=DECIMAL}");
        sql.SET("receiver_object_id = #{record.receiverObjectId,jdbcType=BIGINT}");
        sql.SET("receiver_object_name = #{record.receiverObjectName,jdbcType=VARCHAR}");
        sql.SET("sub_receiver_role = #{record.subReceiverRole,jdbcType=INTEGER}");
        sql.SET("sub_receiver_role_name = #{record.subReceiverRoleName,jdbcType=VARCHAR}");
        sql.SET("sub_receiver_account = #{record.subReceiverAccount,jdbcType=VARCHAR}");
        sql.SET("sub_receiver_name = #{record.subReceiverName,jdbcType=VARCHAR}");
        sql.SET("sub_receiver_ratio = #{record.subReceiverRatio,jdbcType=DECIMAL}");
        sql.SET("sub_receiver_object_id = #{record.subReceiverObjectId,jdbcType=BIGINT}");
        sql.SET("sub_receiver_object_name = #{record.subReceiverObjectName,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("op_user_id = #{record.opUserId,jdbcType=BIGINT}");
        sql.SET("op_user_name = #{record.opUserName,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsTradeTakeConfigExample example = (BsTradeTakeConfigExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsTradeTakeConfig record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_trade_take_config");
        
        if (record.getCompanyId() != null) {
            sql.SET("company_id = #{companyId,jdbcType=BIGINT}");
        }
        
        if (record.getCompanyName() != null) {
            sql.SET("company_name = #{companyName,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformType() != null) {
            sql.SET("platform_type = #{platformType,jdbcType=INTEGER}");
        }
        
        if (record.getPlatformTypeName() != null) {
            sql.SET("platform_type_name = #{platformTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverRole() != null) {
            sql.SET("receiver_role = #{receiverRole,jdbcType=INTEGER}");
        }
        
        if (record.getReceiverRoleName() != null) {
            sql.SET("receiver_role_name = #{receiverRoleName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverAccount() != null) {
            sql.SET("receiver_account = #{receiverAccount,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverName() != null) {
            sql.SET("receiver_name = #{receiverName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverRatio() != null) {
            sql.SET("receiver_ratio = #{receiverRatio,jdbcType=DECIMAL}");
        }
        
        if (record.getReceiverObjectId() != null) {
            sql.SET("receiver_object_id = #{receiverObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getReceiverObjectName() != null) {
            sql.SET("receiver_object_name = #{receiverObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverRole() != null) {
            sql.SET("sub_receiver_role = #{subReceiverRole,jdbcType=INTEGER}");
        }
        
        if (record.getSubReceiverRoleName() != null) {
            sql.SET("sub_receiver_role_name = #{subReceiverRoleName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverAccount() != null) {
            sql.SET("sub_receiver_account = #{subReceiverAccount,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverName() != null) {
            sql.SET("sub_receiver_name = #{subReceiverName,jdbcType=VARCHAR}");
        }
        
        if (record.getSubReceiverRatio() != null) {
            sql.SET("sub_receiver_ratio = #{subReceiverRatio,jdbcType=DECIMAL}");
        }
        
        if (record.getSubReceiverObjectId() != null) {
            sql.SET("sub_receiver_object_id = #{subReceiverObjectId,jdbcType=BIGINT}");
        }
        
        if (record.getSubReceiverObjectName() != null) {
            sql.SET("sub_receiver_object_name = #{subReceiverObjectName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getOpUserId() != null) {
            sql.SET("op_user_id = #{opUserId,jdbcType=BIGINT}");
        }
        
        if (record.getOpUserName() != null) {
            sql.SET("op_user_name = #{opUserName,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsTradeTakeConfigExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}